package markov;

import java.util.Collection;
import java.util.stream.Stream;

public class Collector {

    private final int prefixLength;
    private final Prefix[] slider = new Prefix[]{getNewPrefix()};


    private final Data data;

    public Collector(int prefixLength) {
        this.prefixLength = prefixLength;
        this.data = new Data(prefixLength);
    }

    public void learn(Token token) {
        data.add(slider[0], token);
        slider[0] = slider[0].slide(token, this.prefixLength);
    }

    public void reset() {
        slider[0] = getNewPrefix();
    }

    private Prefix getNewPrefix() {
        return new Prefix(new Token[0]);
    }

    public int getPrefixLength() {
        return prefixLength;
    }

    public Data getData() {
        return data;
    }
}
