package markov;

import java.io.File;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.nio.file.Files;
import java.util.Base64;
import java.util.HashMap;
import java.util.Map;
import java.util.stream.Collectors;
import java.util.stream.Stream;

public class Mail {
    public static void main(String[] args) throws IOException, ClassNotFoundException {
        int prefixLength = 4;
        System.out.println("reading map");
        Map<Integer, Data> dataMap = (Map<Integer, Data>) new ObjectInputStream(Files.newInputStream(new File("C:\\Users\\admin\\git\\markovdisplay\\target\\classes\\data").toPath())).readObject();
        System.out.println("read map");
        Builder b = new Builder(prefixLength, dataMap.get(prefixLength));
        Renderer r = new Renderer(Renderer.Options.FULL);
        Renderer r1 = new Renderer(Renderer.Options.NONE);
        Shortener shortener = new Shortener(dataMap.get(prefixLength));
        CountMap<Integer> counter = new CountMap<>();
        System.out.println("creating...");
        final int max = 100_000;
        for (int i = 0; i < 100_000; i++) {
            if (i % (max / 10) == 0) {
                System.out.println(i / (max / 100) + "%");
            }
            Sentence sentence = b.random();
            String id = shortener.getId(sentence);
            shortener.toInts(id).forEach(c -> counter.count(c));
        }
        System.out.println("distinct: " + counter.map.size());
        System.out.println(counter.result().limit(100).map(e -> e.getValue().get() + "*" + e.getKey()).collect(Collectors.joining("\n")));
        System.out.println("done");
    }


    private static class CountMap<T> {
        static class MutableInt {
            int value = 1;

            public MutableInt(int value) {
                this.value = value;
            }

            public void increment() {
                ++value;
            }

            public int get() {
                return value;
            }
        }

        private final Map<T, MutableInt> map = new HashMap<>();

        public void count(T t) {
            MutableInt i = map.get(t);
            if (i == null) {
                map.put(t, new MutableInt(1));
            } else {
                i.increment();
            }
        }

        public Stream<Map.Entry<T, MutableInt>> result() {
            return map.entrySet().stream().sorted((e1, e2) -> Integer.compare(e2.getValue().get(), e1.getValue().get()));
        }
    }
}
